package com.ebelter.sdksdemo;


import android.app.Activity;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import com.ebelter.sdks.bean.tem.TemMesureResult;
import com.ebelter.sdks.enums.ProductStyle;
import com.ebelter.sdks.interfaces.IBlueStationListener;
import com.ebelter.sdks.interfaces.IConnectStationCallback;
import com.ebelter.sdks.interfaces.tem.ITemMesureResult;
import com.ebelter.sdks.managers.TemManager;
import com.ebelter.sdks.utils.TimeUtils;


public class TemActivity extends Activity {




    private TextView tv0;
    private TextView tv1;
    private TextView tv2;
    private TextView tv3;
    private TextView tv4;

    private TextView mustconnect_tv;


    private Button start;
    private Button stop;

    private TemManager mTemManager;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_tem);

        //-----------01
        mTemManager=new TemManager(this);

        //if targetSdkVersion >22 Open this method, please
        //checkPermissions();
        FV();
        setListeners();
        initData();



    }





    private void setListeners() {

        stop.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                stopWork();
            }
        });
        start.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                startWork();
            }
        });

        mustconnect_tv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                selectMustConnectAddress();
            }
        });



        //-----------02
        mTemManager.addBluetoothStationListener(mBlueStationListener);//Add a mobile phone bluetooth status listener
        mTemManager.setConnectStationCallback(mConnectStationCallback);//Add bluetooth body fat scale connection status listener
        mTemManager.setTemMesureResult(mITemMesureResult);//Add a measurement listening

    }

    private void selectMustConnectAddress() {
        if (mTemManager!=null&&mTemManager.isWorkFlag()){
            mTemManager.stopWork();//先停止工作的意思
        }
        startActivityForResult(new Intent(this,SelectBlueActivity.class),100);
    }

    private void startWork() {


        String mustConnectAddress =mustconnect_tv.getText().toString();
        if (!TextUtils.isEmpty(mustConnectAddress)){
            mTemManager.setMustConnectBlueAddress(mustConnectAddress);
        }
        //-----------05
        mTemManager.startWork();



        // mScaleManager.startWork();//The engine started working
        // mScaleManager.stopWork();//The engine stop working
    }


    //停止工作
    private void stopWork() {
        mTemManager.stopWork();//The engine stop working
    }


    private void FV() {
        tv0 = findViewById(R.id.tv0);
        tv1 = findViewById(R.id.tv1);
        tv2 = findViewById(R.id.tv2);
        tv3 = findViewById(R.id.tv3);
        tv4 = findViewById(R.id.tv4);
        mustconnect_tv = findViewById(R.id.mustconnect_tv);

        start = findViewById(R.id.start);
        stop = findViewById(R.id.stop);
    }

    private void initData() {
        String sdkInfo = "versionName="+AppUtils.getVerName(this)+"-versionCode="+AppUtils.getVersionCode(this);
        setText(tv0,"EbelterSDK info:" + sdkInfo);
        setText(tv1, "Does the phone support bluetooth:       " + (mTemManager.isSupportBluetooth() ? "Support" : "Not Support"));
        setText(tv2, "Bluetooth status of mobile phone:       " + (mTemManager.isBluetoothOpen() ? "Open" : "Closed"));



        //-----------03
        //Set the bluetooth address that must be connected to the bluetooth body fat scale.
        // If it is null, it will randomly scan the connected device
        mTemManager.setMustConnectBlueAddress(null);





    }
    private void setText(TextView tv, String msg) {
        if (tv != null) tv.setText(msg);
    }


    private final IBlueStationListener mBlueStationListener = new IBlueStationListener() {
        @Override
        public void STATE_OFF() {
            setText(tv2, "Bluetooth status of mobile phone:     Closed");
        }

        @Override
        public void STATE_TURNING_OFF() {
            setText(tv2, "Bluetooth status of mobile phone:     Closing...");
        }

        @Override
        public void STATE_ON() {
            setText(tv2, "Bluetooth status of mobile phone:     Open");
        }

        @Override
        public void STATE_TURNING_ON() {
            setText(tv2, "Bluetooth status of mobile phone:     Opening");
        }
    };


    private final IConnectStationCallback mConnectStationCallback=new IConnectStationCallback() {
        @Override
        public void onConnected(ProductStyle productStyle, BluetoothDevice device) {
            addTv4Str("-----onConnected-----"+device.getName()+"--ScaleAddress="+device.getAddress());
            setText(tv3, "Tem device connection status:     Connected"+"\n ScaleName = "+device.getName()+"\nScaleAddress="+device.getAddress());
        }

        @Override
        public void onConnecting(ProductStyle productStyle, BluetoothDevice device) {
            addTv4Str("-----onConnecting-----"+device.getName()+"--ScaleAddress="+device.getAddress());
            setText(tv3, "Tem device connection status:     Connecting "+"\n ScaleName = "+device.getName()+"--ScaleAddress="+device.getAddress());
        }

        @Override
        public void onDisConnected(ProductStyle productStyle) {
            addTv4Str("-----onDisConnected-----");
            setText(tv3, "Tem device connection status:     DisConnected");
        }
    };


    private final ITemMesureResult mITemMesureResult = new ITemMesureResult() {
        @Override
        public void mesureResult(TemMesureResult result) {
            addTv4Str("-----接收到测量结果："+result.toString());
        }

        @Override
        public void mesureOfficeResult(TemMesureResult temMesureResult) {
            addTv4Str("-----接收到历史测量数据："+temMesureResult.toString());
        }

//        @Override
//        public void mesureHisResult(TemMesureResultHis hisResult) {
//            addTv4Str("-----接收到历史测量数据："+hisResult.toString());
//        }

        @Override
        public void error(int errorCode,String blueName) {
            addTv4Str("-----接收到error：errorCode="+errorCode);

//            0x01:测量结果温度低，LCD 显示 L
//            0x02:测结果温度高，LCD 显示 H
//            0x03:环境温度过低，LCD 显示 EL
//            0x04:环境温度过高，LCD 显示 EH
//            0x05:低电压，LCD 显示电池符号
//            0x06:其他Err 测量错误，LCD 显示 Err
        }

        @Override
        public void onDevicePoweroff() {
            addTv4Str("-----接收到设备关机");
        }

        @Override
        public void setUnitSuccess() {
            addTv4Str("-----接收到设置单位成功");
        }

        @Override
        public void getHisDataFinish() {
            addTv4Str("-----接收到获取历史数据完成");
        }

        @Override
        public void getVersion(int versionCode) {
            addTv4Str("-----接收到版本号 versionCode="+versionCode);
        }

        @Override
        public void setTemperatureModeSuccess() {
            addTv4Str("-----温度模式切换成功");
        }
    };



    private void addTv4Str(String addmsg) {
        String str;
        if (tv4 != null) {
            str = tv4.getText().toString();
            if (str.length() > 5000) {
                str = str.substring(0, 5000);
            }
            str =  TimeUtils.getCurrentTime1()+"  "+addmsg+ "\n\n" + str;
            tv4.setText(str);
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mTemManager!=null){
            mTemManager.removeBluetoothStationListener(mBlueStationListener);
            mTemManager.exit();
            mTemManager=null;
        }
    }





    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode==100&&resultCode==101){
            String mustConnectAddress = data.getStringExtra(SelectBlueActivity.ADDRESS);
            if (mustconnect_tv!=null){
                mustconnect_tv.setText(mustConnectAddress);
            }
        }
    }

    //切换单位为°C
    public void setUnitC(View view) {
        if (mTemManager!=null){
            if (!mTemManager.isConnected()){
                ToastUitl.show("请先连接设备");
                return;
            }
            mTemManager.setUnitC();
        }

    }

    //切换单位为°F
    public void setUnitF(View view) {
        if (mTemManager!=null){
            if (!mTemManager.isConnected()){
                ToastUitl.show("请先连接设备");
                return;
            }
            mTemManager.setUnitF();
        }
    }
    //切换耳温
    public void setEerMode(View view) {
        if (mTemManager!=null){
            if (!mTemManager.isConnected()){
                ToastUitl.show("请先连接设备");
                return;
            }
            mTemManager.setTemperatureMode(0);
        }
    }
    //切换耳温
    public void setFrontMode(View view) {
        if (mTemManager!=null){
            if (!mTemManager.isConnected()){
                ToastUitl.show("请先连接设备");
                return;
            }
            mTemManager.setTemperatureMode(1);
        }
    }
    //切换物温
    public void setMaterialMode(View view) {
        if (mTemManager!=null){
            if (!mTemManager.isConnected()){
                ToastUitl.show("请先连接设备");
                return;
            }
            mTemManager.setTemperatureMode(2);
        }
    }
    //切换室温
    public void setIndoorMode(View view) {
        if (mTemManager!=null){
            if (!mTemManager.isConnected()){
                ToastUitl.show("请先连接设备");
                return;
            }
            mTemManager.setTemperatureMode(3);
        }
    }

    //切换室温
    public void getDeviceSn(View view) {
        if (mTemManager!=null){
            if (!mTemManager.isConnected()){
                ToastUitl.show("请先连接设备");
                return;
            }
            String deviceSn = mTemManager.getDeviceSn();
            addTv4Str("设备SN: "+deviceSn);
        }
    }
}
